// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package university_management

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// UniversityManagementServiceClient is the client API for UniversityManagementService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type UniversityManagementServiceClient interface {
	GetDepartment(ctx context.Context, in *GetDepartmentRequest, opts ...grpc.CallOption) (*GetDepartmentResponse, error)
	GetStudent(ctx context.Context, in *GetStudentRequest, opts ...grpc.CallOption) (*GetStudentResponse, error)
	UpdateStudent(ctx context.Context, in *UpdateStudentRequest, opts ...grpc.CallOption) (*Empty, error)
	GetStaffRecordForGivenStudent(ctx context.Context, in *GetStaffRecordRequest, opts ...grpc.CallOption) (*GetStaffRecordResponse, error)
	StudentLogin(ctx context.Context, in *StudentLoginRequest, opts ...grpc.CallOption) (*Empty, error)
	StudentLogout(ctx context.Context, in *StudentLogoutRequest, opts ...grpc.CallOption) (*Empty, error)
}

type universityManagementServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewUniversityManagementServiceClient(cc grpc.ClientConnInterface) UniversityManagementServiceClient {
	return &universityManagementServiceClient{cc}
}

func (c *universityManagementServiceClient) GetDepartment(ctx context.Context, in *GetDepartmentRequest, opts ...grpc.CallOption) (*GetDepartmentResponse, error) {
	out := new(GetDepartmentResponse)
	err := c.cc.Invoke(ctx, "/university_management.UniversityManagementService/GetDepartment", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *universityManagementServiceClient) GetStudent(ctx context.Context, in *GetStudentRequest, opts ...grpc.CallOption) (*GetStudentResponse, error) {
	out := new(GetStudentResponse)
	err := c.cc.Invoke(ctx, "/university_management.UniversityManagementService/GetStudent", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *universityManagementServiceClient) UpdateStudent(ctx context.Context, in *UpdateStudentRequest, opts ...grpc.CallOption) (*Empty, error) {
	out := new(Empty)
	err := c.cc.Invoke(ctx, "/university_management.UniversityManagementService/UpdateStudent", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *universityManagementServiceClient) GetStaffRecordForGivenStudent(ctx context.Context, in *GetStaffRecordRequest, opts ...grpc.CallOption) (*GetStaffRecordResponse, error) {
	out := new(GetStaffRecordResponse)
	err := c.cc.Invoke(ctx, "/university_management.UniversityManagementService/GetStaffRecordForGivenStudent", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *universityManagementServiceClient) StudentLogin(ctx context.Context, in *StudentLoginRequest, opts ...grpc.CallOption) (*Empty, error) {
	out := new(Empty)
	err := c.cc.Invoke(ctx, "/university_management.UniversityManagementService/StudentLogin", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *universityManagementServiceClient) StudentLogout(ctx context.Context, in *StudentLogoutRequest, opts ...grpc.CallOption) (*Empty, error) {
	out := new(Empty)
	err := c.cc.Invoke(ctx, "/university_management.UniversityManagementService/StudentLogout", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// UniversityManagementServiceServer is the server API for UniversityManagementService service.
// All implementations must embed UnimplementedUniversityManagementServiceServer
// for forward compatibility
type UniversityManagementServiceServer interface {
	GetDepartment(context.Context, *GetDepartmentRequest) (*GetDepartmentResponse, error)
	GetStudent(context.Context, *GetStudentRequest) (*GetStudentResponse, error)
	UpdateStudent(context.Context, *UpdateStudentRequest) (*Empty, error)
	GetStaffRecordForGivenStudent(context.Context, *GetStaffRecordRequest) (*GetStaffRecordResponse, error)
	StudentLogin(context.Context, *StudentLoginRequest) (*Empty, error)
	StudentLogout(context.Context, *StudentLogoutRequest) (*Empty, error)
	mustEmbedUnimplementedUniversityManagementServiceServer()
}

// UnimplementedUniversityManagementServiceServer must be embedded to have forward compatible implementations.
type UnimplementedUniversityManagementServiceServer struct {
}

func (UnimplementedUniversityManagementServiceServer) GetDepartment(context.Context, *GetDepartmentRequest) (*GetDepartmentResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetDepartment not implemented")
}
func (UnimplementedUniversityManagementServiceServer) GetStudent(context.Context, *GetStudentRequest) (*GetStudentResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetStudent not implemented")
}
func (UnimplementedUniversityManagementServiceServer) UpdateStudent(context.Context, *UpdateStudentRequest) (*Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateStudent not implemented")
}
func (UnimplementedUniversityManagementServiceServer) GetStaffRecordForGivenStudent(context.Context, *GetStaffRecordRequest) (*GetStaffRecordResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetStaffRecordForGivenStudent not implemented")
}
func (UnimplementedUniversityManagementServiceServer) StudentLogin(context.Context, *StudentLoginRequest) (*Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method StudentLogin not implemented")
}
func (UnimplementedUniversityManagementServiceServer) StudentLogout(context.Context, *StudentLogoutRequest) (*Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method StudentLogout not implemented")
}
func (UnimplementedUniversityManagementServiceServer) mustEmbedUnimplementedUniversityManagementServiceServer() {
}

// UnsafeUniversityManagementServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to UniversityManagementServiceServer will
// result in compilation errors.
type UnsafeUniversityManagementServiceServer interface {
	mustEmbedUnimplementedUniversityManagementServiceServer()
}

func RegisterUniversityManagementServiceServer(s grpc.ServiceRegistrar, srv UniversityManagementServiceServer) {
	s.RegisterService(&UniversityManagementService_ServiceDesc, srv)
}

func _UniversityManagementService_GetDepartment_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetDepartmentRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(UniversityManagementServiceServer).GetDepartment(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/university_management.UniversityManagementService/GetDepartment",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(UniversityManagementServiceServer).GetDepartment(ctx, req.(*GetDepartmentRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _UniversityManagementService_GetStudent_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetStudentRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(UniversityManagementServiceServer).GetStudent(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/university_management.UniversityManagementService/GetStudent",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(UniversityManagementServiceServer).GetStudent(ctx, req.(*GetStudentRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _UniversityManagementService_UpdateStudent_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UpdateStudentRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(UniversityManagementServiceServer).UpdateStudent(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/university_management.UniversityManagementService/UpdateStudent",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(UniversityManagementServiceServer).UpdateStudent(ctx, req.(*UpdateStudentRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _UniversityManagementService_GetStaffRecordForGivenStudent_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetStaffRecordRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(UniversityManagementServiceServer).GetStaffRecordForGivenStudent(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/university_management.UniversityManagementService/GetStaffRecordForGivenStudent",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(UniversityManagementServiceServer).GetStaffRecordForGivenStudent(ctx, req.(*GetStaffRecordRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _UniversityManagementService_StudentLogin_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(StudentLoginRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(UniversityManagementServiceServer).StudentLogin(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/university_management.UniversityManagementService/StudentLogin",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(UniversityManagementServiceServer).StudentLogin(ctx, req.(*StudentLoginRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _UniversityManagementService_StudentLogout_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(StudentLogoutRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(UniversityManagementServiceServer).StudentLogout(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/university_management.UniversityManagementService/StudentLogout",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(UniversityManagementServiceServer).StudentLogout(ctx, req.(*StudentLogoutRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// UniversityManagementService_ServiceDesc is the grpc.ServiceDesc for UniversityManagementService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var UniversityManagementService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "university_management.UniversityManagementService",
	HandlerType: (*UniversityManagementServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetDepartment",
			Handler:    _UniversityManagementService_GetDepartment_Handler,
		},
		{
			MethodName: "GetStudent",
			Handler:    _UniversityManagementService_GetStudent_Handler,
		},
		{
			MethodName: "UpdateStudent",
			Handler:    _UniversityManagementService_UpdateStudent_Handler,
		},
		{
			MethodName: "GetStaffRecordForGivenStudent",
			Handler:    _UniversityManagementService_GetStaffRecordForGivenStudent_Handler,
		},
		{
			MethodName: "StudentLogin",
			Handler:    _UniversityManagementService_StudentLogin_Handler,
		},
		{
			MethodName: "StudentLogout",
			Handler:    _UniversityManagementService_StudentLogout_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "university-management.proto",
}
